/*
  lpt.h
  Matlib 2010-11-11
*/


#ifndef _LPT_H

#define _LPT_H 1

#include <linux/parport.h>




// data bits

#define LPT_P0    0x02
#define LPT_P1    0x08
#define LPT_P2    0x20
#define LPT_P3    0x80

#define LPT_P0EN  0x01
#define LPT_P1EN  0x04
#define LPT_P2EN  0x10
#define LPT_P3EN  0x40



// status bits

#define LPT_P0IN   PARPORT_STATUS_BUSY
#define LPT_P1IN   PARPORT_STATUS_PAPEROUT
#define LPT_P2IN   PARPORT_STATUS_SELECT
#define LPT_P3IN   PARPORT_STATUS_ERROR
#define LPT_INXOR  (LPT_P1IN | LPT_P2IN | LPT_P3IN)



// control bits

#define LPT_VPP    PARPORT_CONTROL_SELECT
#define LPT_RESET  PARPORT_CONTROL_INIT



static int lpt_init (int (*in) (unsigned char *), int (*out) (unsigned char), 
   int (*sin) (unsigned char *), 
   int (*cin) (unsigned char *), int (*cout) (unsigned char));
static int lpt_setport (unsigned pin, unsigned state);
static int lpt_readport (unsigned pin, int *value);
static int lpt_power (int state);
static int lpt_reset (int state);

#endif

