/*
  ppdev.c
  Matlib 2010-12-12
*/

#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include "lpt.c"
#include "linux/ppdev.h"

int ppdev_fd;



static int ppdev_in (unsigned char *data)
{
  SYS_BREAK (ioctl (ppdev_fd, PPRDATA, data) != 0, "ioctl");
  return 0;
}

static int ppdev_out (unsigned char data)
{
  SYS_BREAK (ioctl (ppdev_fd, PPWDATA, &data) != 0, "ioctl");
  return 0;
}

static int ppdev_cin (unsigned char *data)
{
  SYS_BREAK (ioctl (ppdev_fd, PPRCONTROL, data) != 0, "ioctl");
  return 0;
}

static int ppdev_cout (unsigned char data)
{
  SYS_BREAK (ioctl (ppdev_fd, PPWCONTROL, &data) != 0, "ioctl");
  return 0;
}

static int ppdev_sin (unsigned char *data)
{
  SYS_BREAK (ioctl (ppdev_fd, PPRSTATUS, data) != 0, "ioctl");
  return 0;
}



ARGUMENT_CALLBACK (ppdev)
{
  int flags;
  check_driver ();
  SYS_ERROR ((ppdev_fd = open (parameter, O_RDWR | O_NOCTTY))
     == -1, "open", "Cannot open device %s.", parameter);
  SYS_ERROR ((ioctl (ppdev_fd, PPEXCL) != 0) 
     || (ioctl (ppdev_fd, PPCLAIM) != 0), "ioctl", 
     "Cannot get exclusive access to %s.", parameter);
  flags = PARPORT_MODE_PCSPP;
  SYS_ERROR (ioctl (ppdev_fd, PPSETMODE, &flags) != 0, "ioctl",
     "Cannot set parallel port mode for %s.", parameter);

  if (lpt_init (ppdev_in, ppdev_out, ppdev_sin, ppdev_cin, ppdev_cout) != 0)
    exit (EXIT_FAILURE);
}

