/*
  ppdirect.c
  Matlib 2010-10-15
*/

#include <sys/io.h>
#include <string.h>
#include <errno.h>
#include <inttypes.h>

#include "lpt.c"



uint16_t ppdirect_port;



static int ppdirect_in (unsigned char *data)
{
  *data = inb (ppdirect_port);
  return 0;
}

static int ppdirect_out (unsigned char data)
{
  outb (data, ppdirect_port);
  return 0;
}

static int ppdirect_cin (unsigned char *data)
{
  *data = inb (ppdirect_port + 2);
  return 0;
}

static int ppdirect_cout (unsigned char data)
{
  outb (data, ppdirect_port + 2);
  return 0;
}

static int ppdirect_sin (unsigned char *data)
{
  *data = inb (ppdirect_port + 1);
  return 0;
}



ARGUMENT_CALLBACK (ppdirect)
{
  char *tail;
  
  check_driver ();
  ppdirect_port = strtol (parameter, &tail, 0);
  if (*tail != 0)
  {
    printf ("parport: invalid number format: \"%s\"\n", parameter);
    exit (EXIT_FAILURE);
  }
  SYS_ERROR (ioperm (ppdirect_port, 3, 1) != 0, "ioperm", 
     "Cannot get device access priviledges for port 0x%X.", ppdirect_port);
  if (lpt_init (ppdirect_in, ppdirect_out, ppdirect_sin,
     ppdirect_cin, ppdirect_cout) != 0)
    exit (EXIT_FAILURE);
}

