/*
  tpi.h
  Matlib 2010-10-15
*/

#ifndef _TPI_H

#define _TPI_H 1


// LPT interface:
// bit +0 = !ENABLE
// bit +1 = OUTPUT

#define HW_OFF  0
#define HW_ON   2
#define HW_HIZ  3



// tiny pinout

#define TPIDATA   0
#define TPICLK    1
// unused         2
#define TPIRESET  3


#include <inttypes.h>

static int tpi_init ();

static int tpi_clock ();
static int tpi_senddata (int bit);
static int tpi_readdata (int *bit);
static int tpi_sendbyte (unsigned char b);
static int tpi_recvbyte (unsigned char *b);
//static int tpi_break ();

static int tpi_checksig ();
static int tpi_waitnvmen ();
//static int tpi_setnvmen (int sr);
static int tpi_setgt (unsigned gt);
static int tpi_skey ();

static int tpi_sld (unsigned char *b);
static int tpi_sldp (unsigned char *b);
static int tpi_sst (unsigned char b);
static int tpi_sstp (unsigned char b);
static int tpi_sstpr (uint16_t pr);
static int tpi_sin (uint8_t address, unsigned char *b);
static int tpi_sout (uint8_t address, unsigned char b);

#endif

